## quantlib 1.19

=== ql/CMakeLists.txt ===
# cpp files, this list is maintained manually

set(QuantLib_SRC
    cashflow.cpp
    cashflows/averagebmacoupon.cpp
    cashflows/capflooredcoupon.cpp
    cashflows/capflooredinflationcoupon.cpp
    cashflows/cashflows.cpp
    cashflows/cashflowvectors.cpp
    cashflows/cmscoupon.cpp
    cashflows/conundrumpricer.cpp
    cashflows/coupon.cpp
    cashflows/couponpricer.cpp
    cashflows/cpicoupon.cpp
    cashflows/cpicouponpricer.cpp
    cashflows/digitalcmscoupon.cpp
    cashflows/digitalcoupon.cpp
    cashflows/digitaliborcoupon.cpp
    cashflows/dividend.cpp
    cashflows/duration.cpp
    cashflows/fixedratecoupon.cpp
    cashflows/floatingratecoupon.cpp
    cashflows/iborcoupon.cpp
    cashflows/indexedcashflow.cpp
    cashflows/inflationcoupon.cpp
    cashflows/inflationcouponpricer.cpp
    cashflows/lineartsrpricer.cpp
    cashflows/overnightindexedcoupon.cpp
    cashflows/rangeaccrual.cpp
    cashflows/replication.cpp
    cashflows/simplecashflow.cpp
    cashflows/timebasket.cpp
    cashflows/yoyinflationcoupon.cpp
    currencies/africa.cpp
    currencies/america.cpp
    currencies/asia.cpp
    currencies/crypto.cpp
    currencies/europe.cpp
    currencies/exchangeratemanager.cpp
    currencies/oceania.cpp
    currency.cpp
    discretizedasset.cpp
    errors.cpp
    event.cpp
    exchangerate.cpp
    exercise.cpp
    experimental/amortizingbonds/amortizingcmsratebond.cpp
    experimental/amortizingbonds/amortizingfixedratebond.cpp
    experimental/amortizingbonds/amortizingfloatingratebond.cpp
    experimental/averageois/arithmeticaverageois.cpp
    experimental/averageois/arithmeticoisratehelper.cpp
    experimental/averageois/averageoiscouponpricer.cpp
    experimental/averageois/makearithmeticaverageois.cpp
    experimental/barrieroption/analyticdoublebarrierbinaryengine.cpp
    experimental/barrieroption/analyticdoublebarrierengine.cpp
    experimental/barrieroption/mcdoublebarrierengine.cpp
    experimental/barrieroption/discretizeddoublebarrieroption.cpp
    experimental/barrieroption/doublebarrieroption.cpp
    experimental/barrieroption/doublebarriertype.cpp
    experimental/barrieroption/perturbativebarrieroptionengine.cpp
    experimental/barrieroption/quantodoublebarrieroption.cpp
    experimental/barrieroption/vannavolgabarrierengine.cpp
    experimental/barrieroption/wulinyongdoublebarrierengine.cpp
    experimental/basismodels/swaptioncfs.cpp
    experimental/basismodels/tenoroptionletvts.cpp
    experimental/basismodels/tenorswaptionvts.cpp
    experimental/callablebonds/blackcallablebondengine.cpp
    experimental/callablebonds/callablebond.cpp
    experimental/callablebonds/callablebondconstantvol.cpp
    experimental/callablebonds/callablebondvolstructure.cpp
    experimental/callablebonds/discretizedcallablefixedratebond.cpp
    experimental/callablebonds/treecallablebondengine.cpp
    experimental/catbonds/catbond.cpp
    experimental/catbonds/catrisk.cpp
    experimental/catbonds/montecarlocatbondengine.cpp
    experimental/catbonds/riskynotional.cpp
    experimental/commodities/commodity.cpp
    experimental/commodities/commoditycashflow.cpp
    experimental/commodities/commoditycurve.cpp
    experimental/commodities/commodityindex.cpp
    experimental/commodities/commoditypricinghelpers.cpp
    experimental/commodities/commoditysettings.cpp
    experimental/commodities/commoditytype.cpp
    experimental/commodities/commodityunitcost.cpp
    experimental/commodities/dateinterval.cpp
    experimental/commodities/energybasisswap.cpp
    experimental/commodities/energycommodity.cpp
    experimental/commodities/energyfuture.cpp
    experimental/commodities/energyswap.cpp
    experimental/commodities/energyvanillaswap.cpp
    experimental/commodities/paymentterm.cpp
    experimental/commodities/quantity.cpp
    experimental/commodities/unitofmeasure.cpp
    experimental/commodities/unitofmeasureconversion.cpp
    experimental/commodities/unitofmeasureconversionmanager.cpp
    experimental/convertiblebonds/convertiblebond.cpp
    experimental/convertiblebonds/discretizedconvertible.cpp
    experimental/coupons/cmsspreadcoupon.cpp
    experimental/coupons/digitalcmsspreadcoupon.cpp
    experimental/coupons/lognormalcmsspreadpricer.cpp
    experimental/coupons/proxyibor.cpp
    experimental/coupons/quantocouponpricer.cpp
    experimental/coupons/strippedcapflooredcoupon.cpp
    experimental/coupons/subperiodcoupons.cpp
    experimental/coupons/swapspreadindex.cpp
    experimental/credit/basecorrelationstructure.cpp
    experimental/credit/basket.cpp
    experimental/credit/blackcdsoptionengine.cpp
    experimental/credit/cdo.cpp
    experimental/credit/cdsoption.cpp
    experimental/credit/correlationstructure.cpp
    experimental/credit/defaultevent.cpp
    experimental/credit/defaultprobabilitykey.cpp
    experimental/credit/defaulttype.cpp
    experimental/credit/distribution.cpp
    experimental/credit/gaussianlhplossmodel.cpp
    experimental/credit/integralcdoengine.cpp
    experimental/credit/integralntdengine.cpp
    experimental/credit/issuer.cpp
    experimental/credit/lossdistribution.cpp
    experimental/credit/midpointcdoengine.cpp
    experimental/credit/nthtodefault.cpp
    experimental/credit/onefactorcopula.cpp
    experimental/credit/onefactorgaussiancopula.cpp
    experimental/credit/onefactorstudentcopula.cpp
    experimental/credit/pool.cpp
    experimental/credit/randomdefaultmodel.cpp
    experimental/credit/recoveryratemodel.cpp
    experimental/credit/recoveryratequote.cpp
    experimental/credit/riskyassetswap.cpp
    experimental/credit/riskyassetswapoption.cpp
    experimental/credit/riskybond.cpp
    experimental/credit/syntheticcdo.cpp
    experimental/exoticoptions/analyticamericanmargrabeengine.cpp
    experimental/exoticoptions/analyticcomplexchooserengine.cpp
    experimental/exoticoptions/analyticcompoundoptionengine.cpp
    experimental/exoticoptions/analyticeuropeanmargrabeengine.cpp
    experimental/exoticoptions/analyticholderextensibleoptionengine.cpp
    experimental/exoticoptions/analyticpartialtimebarrieroptionengine.cpp
    experimental/exoticoptions/analyticpdfhestonengine.cpp
    experimental/exoticoptions/analyticsimplechooserengine.cpp
    experimental/exoticoptions/analytictwoassetbarrierengine.cpp
    experimental/exoticoptions/analytictwoassetcorrelationengine.cpp
    experimental/exoticoptions/analyticwriterextensibleoptionengine.cpp
    experimental/exoticoptions/complexchooseroption.cpp
    experimental/exoticoptions/compoundoption.cpp
    experimental/exoticoptions/continuousarithmeticasianlevyengine.cpp
    experimental/exoticoptions/continuousarithmeticasianvecerengine.cpp
    experimental/exoticoptions/everestoption.cpp
    experimental/exoticoptions/himalayaoption.cpp
    experimental/exoticoptions/holderextensibleoption.cpp
    experimental/exoticoptions/kirkspreadoptionengine.cpp
    experimental/exoticoptions/margrabeoption.cpp
    experimental/exoticoptions/mceverestengine.cpp
    experimental/exoticoptions/mchimalayaengine.cpp
    experimental/exoticoptions/mcpagodaengine.cpp
    experimental/exoticoptions/pagodaoption.cpp
    experimental/exoticoptions/partialtimebarrieroption.cpp
    experimental/exoticoptions/simplechooseroption.cpp
    experimental/exoticoptions/twoassetbarrieroption.cpp
    experimental/exoticoptions/twoassetcorrelationoption.cpp
    experimental/exoticoptions/writerextensibleoption.cpp
    experimental/finitedifferences/dynprogvppintrinsicvalueengine.cpp
    experimental/finitedifferences/fdextoujumpvanillaengine.cpp
    experimental/finitedifferences/fdhestondoublebarrierengine.cpp
    experimental/finitedifferences/fdklugeextouspreadengine.cpp
    experimental/finitedifferences/fdmblackscholesfwdop.cpp
    experimental/finitedifferences/fdmdupire1dop.cpp
    experimental/finitedifferences/fdmextendedornsteinuhlenbeckop.cpp
    experimental/finitedifferences/fdmextoujumpop.cpp
    experimental/finitedifferences/fdmextoujumpsolver.cpp
    experimental/finitedifferences/fdmhestonfwdop.cpp
    experimental/finitedifferences/fdmhestongreensfct.cpp
    experimental/finitedifferences/fdmklugeextouop.cpp
    experimental/finitedifferences/fdmsquarerootfwdop.cpp
    experimental/finitedifferences/fdmvppstartlimitstepcondition.cpp
    experimental/finitedifferences/fdmvppstepcondition.cpp
    experimental/finitedifferences/fdmvppstepconditionfactory.cpp
    experimental/finitedifferences/fdmzabrop.cpp
    experimental/finitedifferences/fdornsteinuhlenbeckvanillaengine.cpp
    experimental/finitedifferences/fdsimpleextoujumpswingengine.cpp
    experimental/finitedifferences/fdsimpleextoustorageengine.cpp
    experimental/finitedifferences/fdsimpleklugeextouvppengine.cpp
    experimental/finitedifferences/glued1dmesher.cpp
    experimental/finitedifferences/vanillavppoption.cpp
    experimental/futures/overnightindexfuture.cpp
    experimental/futures/overnightindexfutureratehelper.cpp
    experimental/fx/blackdeltacalculator.cpp
    experimental/fx/deltavolquote.cpp
    experimental/inflation/cpicapfloorengines.cpp
    experimental/inflation/cpicapfloortermpricesurface.cpp
    experimental/inflation/yoycapfloortermpricesurface.cpp
    experimental/inflation/yoyoptionlethelpers.cpp
    experimental/lattices/extendedbinomialtree.cpp
    experimental/math/convolvedstudentt.cpp
    experimental/math/expm.cpp
    experimental/math/fireflyalgorithm.cpp
    experimental/math/gaussiancopulapolicy.cpp
    experimental/math/gaussiannoncentralchisquaredpolynomial.cpp
    experimental/math/multidimintegrator.cpp
    experimental/math/multidimquadrature.cpp
    experimental/math/particleswarmoptimization.cpp
    experimental/math/piecewiseintegral.cpp
    experimental/math/tcopulapolicy.cpp
    experimental/math/zigguratrng.cpp
    experimental/mcbasket/adaptedpathpayoff.cpp
    experimental/mcbasket/longstaffschwartzmultipathpricer.cpp
    experimental/mcbasket/mcpathbasketengine.cpp
    experimental/mcbasket/pathmultiassetoption.cpp
    experimental/models/hestonslvfdmmodel.cpp
    experimental/models/hestonslvmcmodel.cpp
    experimental/models/normalclvmodel.cpp
    experimental/models/squarerootclvmodel.cpp
    experimental/processes/extendedblackscholesprocess.cpp
    experimental/processes/extendedornsteinuhlenbeckprocess.cpp
    experimental/processes/extouwithjumpsprocess.cpp
    experimental/processes/gemanroncoroniprocess.cpp
    experimental/processes/hestonslvprocess.cpp
    experimental/processes/klugeextouprocess.cpp
    experimental/processes/vegastressedblackscholesprocess.cpp
    experimental/risk/creditriskplus.cpp
    experimental/risk/sensitivityanalysis.cpp
    experimental/shortrate/generalizedhullwhite.cpp
    experimental/shortrate/generalizedornsteinuhlenbeckprocess.cpp
    experimental/swaptions/haganirregularswaptionengine.cpp
    experimental/swaptions/irregularswap.cpp
    experimental/swaptions/irregularswaption.cpp
    experimental/variancegamma/analyticvariancegammaengine.cpp
    experimental/variancegamma/fftengine.cpp
    experimental/variancegamma/fftvanillaengine.cpp
    experimental/variancegamma/fftvariancegammaengine.cpp
    experimental/variancegamma/variancegammamodel.cpp
    experimental/variancegamma/variancegammaprocess.cpp
    experimental/varianceoption/integralhestonvarianceoptionengine.cpp
    experimental/varianceoption/varianceoption.cpp
    experimental/volatility/abcdatmvolcurve.cpp
    experimental/volatility/blackatmvolcurve.cpp
    experimental/volatility/blackvolsurface.cpp
    experimental/volatility/equityfxvolsurface.cpp
    experimental/volatility/extendedblackvariancecurve.cpp
    experimental/volatility/extendedblackvariancesurface.cpp
    experimental/volatility/interestratevolsurface.cpp
    experimental/volatility/noarbsabr.cpp
    experimental/volatility/noarbsabrabsprobs.cpp
    experimental/volatility/noarbsabrinterpolatedsmilesection.cpp
    experimental/volatility/noarbsabrsmilesection.cpp

=== test-suite/CMakeLists.txt ===
# cpp files, this list is maintained manually

set(QuantLib-Test_SRC
    americanoption.cpp
    amortizingbond.cpp
    andreasenhugevolatilityinterpl.cpp
    array.cpp
    asianoptions.cpp
    assetswap.cpp
    autocovariances.cpp
    barrieroption.cpp
    basismodels.cpp
    basketoption.cpp
    batesmodel.cpp
    bermudanswaption.cpp
    binaryoption.cpp
    blackdeltacalculator.cpp
    blackformula.cpp
    bonds.cpp
    brownianbridge.cpp
    businessdayconventions.cpp
    calendars.cpp
    capfloor.cpp
    capflooredcoupon.cpp
    cashflows.cpp
    catbonds.cpp
    cdo.cpp
    cdsoption.cpp
    chooseroption.cpp
    cliquetoption.cpp
    cms.cpp
    cmsspread.cpp
    commodityunitofmeasure.cpp
    compiledboostversion.cpp
    compoundoption.cpp
    convertiblebonds.cpp
    covariance.cpp
    creditdefaultswap.cpp
    creditriskplus.cpp
    curvestates.cpp
    dates.cpp
    daycounters.cpp
    defaultprobabilitycurves.cpp
    digitalcoupon.cpp
    digitaloption.cpp
    distributions.cpp
    dividendoption.cpp
    doublebarrieroption.cpp
    doublebinaryoption.cpp
    europeanoption.cpp
    everestoption.cpp
    exchangerate.cpp
    extendedtrees.cpp
    extensibleoptions.cpp
    fastfouriertransform.cpp
    fdcev.cpp
    fdheston.cpp
    fdcir.cpp
    fdmlinearop.cpp
    fdsabr.cpp
    fittedbonddiscountcurve.cpp
    forwardoption.cpp
    forwardrateagreement.cpp
    functions.cpp
    garch.cpp
    gaussianquadratures.cpp
    gjrgarchmodel.cpp
    gsr.cpp
    hestonmodel.cpp
    hestonslvmodel.cpp
    himalayaoption.cpp
    hybridhestonhullwhiteprocess.cpp
    indexes.cpp
    inflation.cpp
    inflationcapfloor.cpp
    inflationcapflooredcoupon.cpp
    inflationcpibond.cpp
    inflationcpicapfloor.cpp
    inflationcpiswap.cpp
    inflationvolatility.cpp
    instruments.cpp
    integrals.cpp
    interestrates.cpp
    interpolations.cpp
    jumpdiffusion.cpp
    lazyobject.cpp
    libormarketmodel.cpp
    libormarketmodelprocess.cpp
    linearleastsquaresregression.cpp
    lookbackoptions.cpp
    lowdiscrepancysequences.cpp
    main.cpp
    margrabeoption.cpp
    marketmodel.cpp
    marketmodel_cms.cpp
    marketmodel_smm.cpp
    marketmodel_smmcapletalphacalibration.cpp
    marketmodel_smmcapletcalibration.cpp
    marketmodel_smmcaplethomocalibration.cpp
    markovfunctional.cpp
    matrices.cpp
    mclongstaffschwartzengine.cpp
    mersennetwister.cpp
    money.cpp
    noarbsabr.cpp
    normalclvmodel.cpp
    nthorderderivativeop.cpp
    nthtodefault.cpp
    numericaldifferentiation.cpp
    observable.cpp
    ode.cpp
    operators.cpp
    optimizers.cpp
    optionletstripper.cpp
    overnightindexedswap.cpp
    pagodaoption.cpp
    partialtimebarrieroption.cpp
    pathgenerator.cpp
    period.cpp
    piecewiseyieldcurve.cpp
    piecewisezerospreadedtermstructure.cpp
    quantlibtestsuite.cpp
    quantooption.cpp
    quotes.cpp
    rangeaccrual.cpp
    riskneutraldensitycalculator.cpp
    riskstats.cpp
    rngtraits.cpp
    rounding.cpp
    sampledcurve.cpp
    schedule.cpp
    shortratemodels.cpp
    sofrfutures.cpp
    solvers.cpp
    spreadoption.cpp
    squarerootclvmodel.cpp
    stats.cpp
    swap.cpp
    swapforwardmappings.cpp
    swaption.cpp
    swaptionvolatilitycube.cpp
    swaptionvolatilitymatrix.cpp
    swingoption.cpp
    termstructures.cpp
    timegrid.cpp
    timeseries.cpp
    tqreigendecomposition.cpp
    tracing.cpp
    transformedgrid.cpp
    twoassetbarrieroption.cpp
    twoassetcorrelationoption.cpp
    utilities.cpp
    variancegamma.cpp
    varianceoption.cpp
    varianceswaps.cpp
    volatilitymodels.cpp
    vpp.cpp
    zabr.cpp
)

set(BENCHMARK_FILES "main.cpp" "quantlibbenchmark.cpp" "americanoption.cpp" "asianoptions.cpp" "barrieroption.cpp"
       "basketoption.cpp" "batesmodel.cpp" "convertiblebonds.cpp" "digitaloption.cpp" "dividendoption.cpp"
       "europeanoption.cpp" "fdheston.cpp" "hestonmodel.cpp" "interpolations.cpp" "jumpdiffusion.cpp"
       "marketmodel_smm.cpp" "marketmodel_cms.cpp" "lowdiscrepancysequences.cpp" "quantooption.cpp" "riskstats.cpp"
       "shortratemodels.cpp" "utilities.cpp" "utilities.hpp" "swaptionvolstructuresutilities.hpp")

if (USE_BOOST_DYNAMIC_LIBRARIES)
    add_definitions(-DBOOST_TEST_DYN_LINK)
endif()

find_package (Boost REQUIRED COMPONENTS unit_test_framework timer system OPTIONAL_COMPONENTS chrono)

set (TEST quantlib-test-suite)
add_executable (${TEST} ${QuantLib-Test_SRC})
target_link_libraries (${TEST} ${QL_LINK_LIBRARY} ${Boost_LIBRARIES})
set_property(TARGET ${TEST} PROPERTY PROJECT_LABEL "testsuite")

set (BENCHMARK quantlib-benchmark)
add_executable (${BENCHMARK} ${BENCHMARK_FILES})
target_link_libraries (${BENCHMARK} ${QL_LINK_LIBRARY} ${Boost_LIBRARIES})
set_property(TARGET ${BENCHMARK} PROPERTY PROJECT_LABEL "benchmark")

add_test (${TEST} ${TEST})

=== debian/changelog ===
quantlib (1.19-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 20 Jul 2020 08:33:08 -0500

quantlib (1.18-1.1804.2) bionic; urgency=medium

  * PPA build for Ubuntu 18.04 ("bionic")

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 23 Mar 2020 14:08:49 -0500

quantlib (1.18-1.1910.1) eoan; urgency=medium

  * PPA build for Ubuntu 19.10 ("eoan")

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 23 Mar 2020 08:47:47 -0500

quantlib (1.18-1) unstable; urgency=medium

  * New upstream release

  * debian/control: Update Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 23 Mar 2020 07:10:20 -0500

=== debian/control ===
Source: quantlib
Section: libs
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Build-Depends: debhelper (>= 10), autoconf, automake, texinfo, libboost-dev, libboost-test-dev, libboost-timer-dev, libboost-system-dev, g++ (>= 4:5.2), dh-autoreconf
Standards-Version: 4.5.0

Package: libquantlib0v5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks:  libquantlib-1.1, libquantlib-1.0.0
Replaces: libquantlib-1.2, libquantlib-1.1, libquantlib-1.0.0, libquantlib0
Conflicts: libquantlib0
Provides: libquantlib-1.2, libquantlib-1.1, libquantlib-1.0.0
Description: Quantitative Finance Library -- library package
 The QuantLib project aims to provide a comprehensive software framework 
 for quantitative finance. The goal is to provide a standard free/open 
 source library to quantitative analysts and developers for modeling, 
 trading, and risk management of financial assets.
 .
 This package provides the shared libraries required to run programs 
 compiled with QuantLib.

Package: libquantlib0-dev
Architecture: any
Section: libdevel
Replaces: libquantlib0, libquantlib-0.3.9
Depends: ${shlibs:Depends}, ${misc:Depends}, libc6-dev, libboost-test-dev, libquantlib0v5 (= ${binary:Version})
Description: Quantitative Finance Library -- development package
 The QuantLib project aims to provide a comprehensive software framework 
 for quantitative finance. The goal is to provide a standard free/open 
 source library to quantitative analysts and developers for modeling, 
 trading, and risk management of financial assets.
 .
 This package contains the header files, static libraries and symbolic 
 links that developers using QuantLib will need.

Package: quantlib-examples
Architecture: any
Section: devel
Depends: ${shlibs:Depends}, ${misc:Depends}, libquantlib0v5 (= ${binary:Version})
Breaks: libquantlib0v5 (<< 1.17-1)
Replaces: libquantlib0v5 (<< 1.17-1)
Description: Quantitative Finance Library -- example binaries
 The QuantLib project aims to provide a comprehensive software framework 
 for quantitative finance. The goal is to provide a standard free/open 
 source library to quantitative analysts and developers for modeling, 
 trading, and risk management of financial assets.
 .
 This package provides several example binaries as well as source code.

## quantlib 1.21

=== CMakeLists.txt ===
cmake_minimum_required()

project(QuantLib)

include(CTest)
include(${CMAKE_CURRENT_LIST_DIR}/cmake/quantlib.cmake)

option(BUILD_SHARED_LIBS "Build shared libraries" ${UNIX})
option(USE_BOOST_DYNAMIC_LIBRARIES "Use the shared version of Boost libraries" ${UNIX})
if (USE_BOOST_DYNAMIC_LIBRARIES)
    add_definitions(-DBOOST_ALL_DYN_LINK)
else()
    set(Boost_USE_STATIC_LIBS ON)
endif()

if (MSVC)
    set(MSVC_RUNTIME "dynamic" CACHE STRING "MSVC runtime to link")
    set_property(CACHE MSVC_RUNTIME PROPERTY STRINGS static dynamic)
    configure_msvc_runtime()

    if(${MSVC_RUNTIME} STREQUAL "static")
        if(USE_BOOST_DYNAMIC_LIBRARIES)
            message(FATAL_ERROR "Use of shared Boost libraries while compiling with static runtime seems not be a good idea.")
        endif()
        set(Boost_USE_STATIC_RUNTIME ON)
    endif()

    # Remove warnings
    add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS)
endif()

# On single-configuration builds, select a default build type that
# gives the same compilation flags as a default autotools build.
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()

# to reference headers via <ql/foo.hpp>, we need to add the root
# directory of the project to includes
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

find_package(Boost 1.48.0)
if (Boost_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
endif (Boost_FOUND)

add_subdirectory(ql)
add_subdirectory(Examples)
add_subdirectory(test-suite)

#
# Copy across the ANSI config file into the build directory. Users
# need to change userconfig.hpp if they require different settings.
#
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ql/config.ansi.hpp
  ${PROJECT_BINARY_DIR}/config.hpp COPYONLY)
install(FILES ${PROJECT_BINARY_DIR}/config.hpp DESTINATION include/ql)

=== ql/CMakeLists.txt ===
--- 
+++ 
@@ -47,6 +47,8 @@
     experimental/amortizingbonds/amortizingcmsratebond.cpp
     experimental/amortizingbonds/amortizingfixedratebond.cpp
     experimental/amortizingbonds/amortizingfloatingratebond.cpp
+    experimental/asian/analytic_cont_geom_av_price_heston.cpp
+    experimental/asian/analytic_discr_geom_av_price_heston.cpp
     experimental/averageois/arithmeticaverageois.cpp
     experimental/averageois/arithmeticoisratehelper.cpp
     experimental/averageois/averageoiscouponpricer.cpp
@@ -183,6 +185,7 @@
     experimental/finitedifferences/fdsimpleklugeextouvppengine.cpp
     experimental/finitedifferences/glued1dmesher.cpp
     experimental/finitedifferences/vanillavppoption.cpp
+    experimental/forward/analytichestonforwardeuropeanengine.cpp
     experimental/futures/overnightindexfuture.cpp
     experimental/futures/overnightindexfutureratehelper.cpp
     experimental/fx/blackdeltacalculator.cpp
@@ -241,6 +244,3 @@
     experimental/volatility/extendedblackvariancesurface.cpp
     experimental/volatility/interestratevolsurface.cpp
     experimental/volatility/noarbsabr.cpp
-    experimental/volatility/noarbsabrabsprobs.cpp
-    experimental/volatility/noarbsabrinterpolatedsmilesection.cpp
-    experimental/volatility/noarbsabrsmilesection.cpp

=== test-suite/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,7 @@
     brownianbridge.cpp
     businessdayconventions.cpp
     calendars.cpp
+    callablebonds.cpp
     capfloor.cpp
     capflooredcoupon.cpp
     cashflows.cpp
@@ -149,6 +150,7 @@
     transformedgrid.cpp
     twoassetbarrieroption.cpp
     twoassetcorrelationoption.cpp
+    ultimateforwardtermstructure.cpp
     utilities.cpp
     variancegamma.cpp
     varianceoption.cpp

=== Examples/BermudanSwaption/CMakeLists.txt ===
add_executable(BermudanSwaption BermudanSwaption.cpp)
target_link_libraries(BermudanSwaption ${QL_LINK_LIBRARY})

=== Examples/CDS/CMakeLists.txt ===
add_executable(CDS CDS.cpp)
target_link_libraries(CDS ${QL_LINK_LIBRARY})

=== Examples/EquityOption/CMakeLists.txt ===
add_executable(EquityOption EquityOption.cpp)
target_link_libraries(EquityOption ${QL_LINK_LIBRARY})

=== Examples/FRA/CMakeLists.txt ===
add_executable(FRA FRA.cpp)
target_link_libraries(FRA ${QL_LINK_LIBRARY})

=== debian/changelog ===
quantlib (1.21-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 20 Jan 2021 07:20:30 -0600

quantlib (1.20-1.2004.1) focal; urgency=medium

  * PPA build for Ubuntu 20.04 ("focal")

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 26 Oct 2020 09:11:49 -0500

quantlib (1.20-1) unstable; urgency=medium

  * New upstream release

  * debian/control: Switch to virtual debhelper-compat (= 11)
  * debian/compat: Removed

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 26 Oct 2020 07:47:18 -0500

quantlib (1.19-1.2004.1) focal; urgency=medium

  * PPA build for Ubuntu 20.04 ("focal")

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 20 Jul 2020 10:56:46 -0500

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,11 @@
 Section: libs
 Priority: optional
 Maintainer: Dirk Eddelbuettel <edd@debian.org>
-Build-Depends: debhelper (>= 10), autoconf, automake, texinfo, libboost-dev, libboost-test-dev, libboost-timer-dev, libboost-system-dev, g++ (>= 4:5.2), dh-autoreconf
+Build-Depends: debhelper-compat (= 11), autoconf, automake, texinfo, libboost-dev, libboost-test-dev, libboost-timer-dev, libboost-system-dev, g++ (>= 4:5.2), dh-autoreconf
 Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/edd/quantlib
+Vcs-Git: https://salsa.debian.org/edd/quantlib.git
+Homepage: https://www.quantlib.org
 
 Package: libquantlib0v5
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
#                                                       -*- makefile -*-
# debian/rules file for the Debian/GNU Linux quantlib package
# Copyright (C) 2001 - 2016 by Dirk Eddelbuettel <edd@debian.org>

source  := $(shell head -1 debian/changelog | awk '{print $$1}')
# 'quantlib-config --version' after configure is easier ...

# that currently gets 1.0 only
# reverted back to using libquantlib0
#sonum   := 1.3
#sonum	:= $(shell grep AC_INIT configure.ac | \
#			perl -ne 'm/([0-9\\.]+)/ and print $$1')
#libpkg  := lib$(source)-$(sonum)
#libpkg  := lib$(source)-1.1
libpkg  := lib$(source)0v5

devpkg  := lib$(source)0-dev
smppkg  := $(source)-examples
debtmp	:= $(CURDIR)/debian/$(libpkg)
libdoc	:= $(CURDIR)/debian/$(libpkg)/usr/share/doc/$(libpkg)
arch 	:= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
cpu	:= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)

#export DH_VERBOSE=1

## edd 29 Nov 2001	Default to g++
## edd 18 Jun 2005 	g++-3.4 for testing
## edd 18 Jul 2005      back to g++
## edd 17 Nov 2005	g++-4.0
## edd 16 Mar 2006      back to g++
cxx	= g++

## edd 13 Apr 2014	use dpkg-buildflags as a base
cxxbuildflags   = 	$(shell dpkg-buildflags --get CXXFLAGS)
cppbuildflags   = 	$(shell dpkg-buildflags --get CPPFLAGS)
buildflags      =       $(cxxbuildflags) $(cppbuildflags)
ldflags  =	 	$(shell dpkg-buildflags --get LDFLAGS)

## edd 18 May 2002	standard flags for libraries
## edd 18 Jun 2005 	no optim., debugging
## edd 18 Jul 2005	back to normal
## edd 17 Nov 2005	added -fpermissive for 0.3.11-2
## edd 13 Apr 2014      use buildflags as base
compilerflags   = $(buildflags) -g0 -O2 -D_REENTRANT -fpermissive

# edd 14 Jan 2003  no longer override g++ as 3.2 is now default everywhere
## 			but use g++-3.0 on ia64
#ifneq "$(findstring $(arch), ia64-linux)" ""
#cxx	= g++-3.0
#endif

## edd 18 May 2002	no optimisation or debugging on baby systems
## edd 14 May 2005	don't do it on mipsel or mips either
## edd 26 Jun 2007 	use cpu test, not arch test -- thanks to Riku via #430709
## edd 13 Apr 2014      use buildflags as base
## edd 18 May 2017      add mipsel64
## bunk 25 Sep 2017     comment out, all buildds are now able to build with -O2
#ifneq "$(findstring $(cpu), m68k arm armeb mipsel mips mipsel64)" ""
#compilerflags   = $(buildflags) -O0 -g0 -D_REENTRANT -fpermissive
#endif

### edd 22 Dec 2002  g++-3.2 for s390
#ifneq "$(findstring $(arch), s390-linux)" ""
#cxx	= g++-3.2
#endif

## edd 19 June 2004	no optimisation on amd64 (#255100)
#ifneq "$(findstring $(arch), x86_64-linux)" ""
#compilerflags   = -O0 -D_REENTRANT
#endif

upstream: get-orig-source
get-orig-source:
        #lynx http://quantlib.org/download.html
        #lynx http://prdownloads.sf.net/quantlib
	links http://quantlib.org/download.shtml

prerelease:
#	links http://quantlib.org/gm/
#	links http://quantlib.org/prerelease
	links https://sourceforge.net/projects/quantlib/files/prerelease

configure: configure-stamp
configure-stamp:
	dh_testdir
	dh_autoreconf
        #./autogen.sh
	CXX=$(cxx) 						\
	CXXFLAGS="$(compilerflags)"				\
	CFLAGS="$(compilerflags)"				\
	LDFLAGS="$(ldflags)"                                    \
	./configure 	--prefix=/usr 				\
			--enable-openmp   			\
			--enable-intraday			\
			--enable-examples			\
			--enable-benchmark			\
			--enable-shared 			\
			--enable-static 			\
			--with-gnu-ld 				\
			--mandir=$(debtmp)/usr/share/man 	\
			--build $(arch)
        # patch libtool re rpath (see lintian docu)
	sed < libtool > libtool-2 \
			-e 's/^hardcode_libdir_flag_spec.*$$/hardcode_libdir_flag_spec=" -D__LIBTOOL_IS_A_FOOL__ "/' \
			-e '/^archive_cmds="/s/"$$/ \\$$deplibs"/'
	mv libtool-2 libtool
	chmod 755 libtool
        # end libtool rpath patch
	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: configure-stamp
	dh_testdir
	-$(MAKE) 	CFLAGS="$(compilerflags)"  	\
			CXXFLAGS="$(compilerflags)"  	\
			LDFLAGS="$(ldflags)"            \
			CXX=$(cxx)

        # edd 17 May 2005  create shlibs on the fly
        # edd 11 Feb 2007  libQuantLibFunctions is no more
	# edd 07 Mar 2012  need to tag this as so number 0
	# edd 01 Sep 2013  back to libquantlib0 and fixed file
	#@echo "libQuantLib ${sonum} libquantlib-${sonum}" \
	#	> debian/libquantlib-${sonum}.shlibs
	#@echo "libQuantLib 0 libquantlib-${sonum}" \
	#	> debian/shlibs.local
        #@echo "libQuantLibFunctions ${sonum} libquantlib-${sonum}" \
        #	>> debian/libquantlib-${sonum}.shlibs

	touch build-stamp

test:	test-stamp
test-stamp: build-stamp
ifeq "$(findstring $(cpu), m68k arm aarch64 armeb armel mipsel mips mips64el hppa)" ""
	-LD_LIBRARY_PATH=$(CURDIR)/ql/.libs $(MAKE) check
        #-LD_LIBRARY_PATH=$(CURDIR)/ql/.libs $(MAKE) benchmark
endif
	touch test-stamp

clean:
	dh_testdir
	dh_testroot
	dh_autoreconf_clean
	rm -f configure-stamp build-stamp install-stamp test-stamp
	rm -rf debian/static/
	dh_clean lib/*so* build/*.so*
	[ ! -f Makefile ] || $(MAKE) distclean
	-rm -rf config.log config.status
	#-rm -rf debian/libquantlib-${sonum}.shlibs

install: install-stamp
install-stamp: test-stamp
	$(MAKE) -f debian/rules DH_OPTIONS= install-work
install-work:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	-$(MAKE) prefix=$(debtmp)/usr	 	  install
	-$(MAKE) prefix=$(debtmp)/usr	 	  install-am
        # clean usr/aclocal
	rm -rvf 	$(debtmp)/usr/aclocal
	dh_installexamples	-p$(libpkg)	Examples/ 	\
						test-suite/	\
						quantlib.el
	(cd $(libdoc)/examples/Examples; 			\
		rm -vf  */*.o */*.dsp */*.mak *.dsw *.mak;	\
		rm -rvf */.deps/ */.libs/;			\
		find . -type f -perm 0755 | xargs rm -vf ) || true
	(cd $(libdoc)/examples/test-suite; 			\
		rm -rvf  *.o .deps/ .libs/;			\
		find . -type f -perm 0755 | xargs rm -vf ) || true
#	dh_installman	-p$(devpkg)	debian/quantlib-test-suite.1
        # now part of upstream: debian/DiscreteHedging.1 \
        #                       debian/quantlib-config.1 \
        # defunct		debian/Parities.1
#	dh_installdirs 	-p$(smppkg) 	usr/share/man/man1
#	dh_installman	-p$(smppkg)	debian/EquityOption.1 \
#					debian/ConvertibleBonds.1
#	dh_installman	-p$(smppkg)	debian/FittedBondCurve.1
#	dh_installman	-p$(smppkg)	debian/CDS.1 debian/CallableBonds.1
        # install -d debian/libquantlib0/usr/bin
        # install -m 0755 -c quantlib-config debian/libquantlib0/usr/bin
        # move static libs into dev-package
	dh_movefiles 	-p$(devpkg) --sourcedir=debian/$(libpkg)
        # move example files into smp-package
	dh_movefiles 	-p$(smppkg) --sourcedir=debian/$(libpkg)
        # some cleanup after movefiles
	-rm -vf  	$(debtmp)/usr/lib/lib*.la
	-rm -rvf 	$(debtmp)/usr/include
	-rm -rvf	$(debtmp)/usr/share/doc/$(libpkg)/examples/
        # install lintian "silencer"
        # edd 15 May 2005  no longer needed	#
        #dh_installdirs -p$(libpkg) usr/share/lintian/overrides
        #install -p -m 0644  debian/$(libpkg).lintian \
        #	$(debtmp)/usr/share/lintian/overrides/$(libpkg)
        # remove redundant LGPL license
	rm -vf 	$(CURDIR)/debian/$(devpkg)/usr/share/doc/$(libpkg)/examples/test-suite/CPPUNIT-COPYING
        # try this here
	dh_installchangelogs	-p$(libpkg) -N$(devpkg) -N$(smppkg) ChangeLog.txt
        # remove empty examples/ dir
#	rm -vf 	$(CURDIR)/debian/$(devpkg)/usr/share/doc/$(libpkg)/examples/test-suite/CPPUNIT-COPYING
	touch install-stamp

# This single target is used to build all the packages, all at once, or
# one at a time. So keep in mind: any options passed to commands here will
# affect _all_ packages. Anything you want to only affect one package
# should be put in another target, such as the install target.
binary-common: build test install
	dh_testdir
	dh_testroot
#	dh_installdebconf
	dh_link			-p$(smppkg) -p$(devpkg)
	dh_installdocs		-p$(libpkg) -N$(devpkg) -N$(smppkg)	\
						README.md  		\
						Contributors.txt 	\
						News.md
#	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installinit
#	dh_installcron
#	dh_installinfo

## quantlib 1.23

=== debian/changelog ===
quantlib (1.23-2) unstable; urgency=medium

  *  Simple rebuild for unstable following Debian 11 release
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 15 Aug 2021 07:04:30 -0500

quantlib (1.23-1.2004.1) focal; urgency=medium

  * PPA build for Ubuntu 20.04 ("focal")

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 14 Jul 2021 09:25:39 -0500

quantlib (1.23-1) experimental; urgency=medium

  * New upstream release (to experimental during freeze)

  * debian/control: Update Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 14 Jul 2021 06:46:01 -0500

quantlib (1.22-1.2004.1) focal; urgency=medium

  * PPA build for Ubuntu 20.04 ("focal")

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 15 Apr 2021 12:04:44 -0500

quantlib (1.22-1) experimental; urgency=medium

  * New upstream release, upload to experimental during (soft) freeze

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 15 Apr 2021 08:36:17 -0500

quantlib (1.21-1.2004.1) focal; urgency=medium

  * PPA build for Ubuntu 20.04 ("focal")

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 20 Jan 2021 08:52:59 -0600

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Dirk Eddelbuettel <edd@debian.org>
 Build-Depends: debhelper-compat (= 11), autoconf, automake, texinfo, libboost-dev, libboost-test-dev, libboost-timer-dev, libboost-system-dev, g++ (>= 4:5.2), dh-autoreconf
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/edd/quantlib
 Vcs-Git: https://salsa.debian.org/edd/quantlib.git
 Homepage: https://www.quantlib.org
